﻿define([
// libs
    'jquery',
// live monitor
    'components/ComponentFactory'
],

function (
// libs
    $,
// live monitor
    componentFactory
) {

    // =================================================================================================================================================
    // 'LiveMonitorNotification' class information
    // =================================================================================================================================================
    // module:
    //      'App/Components/Notification/LiveMonitorNotification'
    // summary:
    //      The jQuery plugin for notification component
    // description:
    //      use:
    //          $(target).LiveMonitorNotification(options);
    //      options:
    //          resources: [Object]
    //          templateString [String]
    //          baseClasses [String]
    // tags:
    //      public

    // Create the defaults once
    var pluginName = 'LiveMonitorNotification',
        pluginOptions = {
            templateString: '',
            baseClasses: 'livemonitor-notification'
        };

    // A really lightweight plugin wrapper around the constructor, 
    //  preventing against multiple instantiations
    $.fn[pluginName] = function (/*Object*/options) {
        // summary:
        //      Create a new jQuery plugin from the given settings
        // options: [Object]
        //      The given settings that wanted to decorates the default settings of the current component
        // returns: [Object]
        //      The jQuery plugin object
        // tags:
        //      protected

        // Decorates the default settings by the given settings
        $.extend(true, pluginOptions, options);

        // Create and then return a new jQuery plugin object
        return componentFactory.create(this, pluginName, null, pluginOptions);
    };

});